import axios from 'axios';
import { API_URL_ADDITIONAL_SERVICE } from '@/shared/api/api-url-additional-service';
import { resultify } from '@/shared/lib/resultify';
import { NiceAxiosError } from '@/shared/@types/error';
import {
  ExtensionCheckParams,
  ExtensionCheckResponse
} from '../model/types';
import {
  useMutation,
  UseMutationOptions
} from '@tanstack/react-query';
import { getHeaderUserAgent } from '@/shared/constants/url';

export const extensionCheck = (params: ExtensionCheckParams) => {
  let headerOptions = {
    menuId: 51,
    apiType: 'SELECT'
  };
  let options = {
    headers: {
      'X-User-Agent': getHeaderUserAgent(headerOptions)
    }
  };
  return resultify(
    axios.post<ExtensionCheckResponse>(API_URL_ADDITIONAL_SERVICE.extensionCheck(), params, options),
  );
};

export const useExtensionCheckMutation = (options?: UseMutationOptions<ExtensionCheckResponse, NiceAxiosError, ExtensionCheckParams>) => {
  const mutation = useMutation<ExtensionCheckResponse, NiceAxiosError, ExtensionCheckParams>({
    ...options,
    mutationFn: (params: ExtensionCheckParams) => extensionCheck(params),
  });

  return {
    ...mutation,
  };
};